#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "acidblood.h"
#include "acidfuncs.h"
#include "tracking.h"
#include "events.h"
#include "list.h"  //linktolist
#include "config.h"

struct chfiles {
	struct chfiles *prev ;
   
	FILE           *file ;
	char           *channel ; 
   time_t         created;
   
	struct chfiles *next ;
} ;

struct chfiles *channel_files = NULL;

void logmod_utterance(int event, struct socket_info *sinfo, char *nick, char *dest, char *info);
void releaseLogfiles(void) ;
FILE* GetFileHandle(char *channel) ;


int module_init(void *module) {
  
   addtrigger(module, EV_MSG, logmod_utterance );
   
   return(0) ;
}


int module_shutdown(void *module) {

   deltrigger(module, EV_MSG );
   
   releaseLogfiles();

	return(0) ;
}


void logmod_utterance(int event, struct socket_info *sinfo, char *nick, char *dest, char *info) {

  time_t         currtime;
  char           timestring[50];
  FILE           * fout;
  
  char           * temp1;
  char           * temp2;
  char           * temp3;

  /*
  if ( *(dest) != '#') {  // dont log non channel events
     return;
  }
  */
 


  if (( fout =  GetFileHandle( dest )) == NULL) {
       privmsg(sinfo, dest, "Help I can't open my diary! \n");
       return;
  }

  if (ftell(fout) == 0) {  // add headers to a new file
    fprintf(fout, "<html>\n");
    fprintf(fout, "<body alink=\"#000099\" vlink=\"#990099\" link=\"#000099\" bgcolor=\"#000000\" text=\"#000000\">\n");
    fprintf(fout, "<div align=\"center\"><font color=\"#ffff66\"><big><big><b>%s</b></big></big></font></div><tt>\n", dest);
  }


  
  /*
  < = &lt;  4 (+3)
  & = &amp; 5 (+4)
  > = &gt;  4 (+3)
  */
  
  temp1 = strdup(info);                          //  temp1 = "asdf<lkj"
  
  temp3 = strdup(temp1);                         //  temp3 = "asdf<lkj"
  while((temp2 = strchr(temp1,'<')) != NULL) {   //  temp2 = "<lkj"
    strcpy(temp3, temp2+1);                      //  temp3 = "lkj"
    realloc(temp1, strlen(temp1)+4);             //  temp1 = "asdf<lkj___"
    strcpy(temp2, "&lt;");                       //  temp1 = "asdf&lt;___"
    strcat(temp1, temp3);                        //  temp1 = "asdf&lt;lkj"
  }
  free(temp3);
 
  temp3 = strdup(temp1);                          
  while((temp2 = strchr(temp1,'&')) != NULL) {   
    strcpy(temp3, temp2+1);                      
    realloc(temp1, strlen(temp1)+5);             
    strcpy(temp2, "&amp;");                       
    strcat(temp1, temp3);                       
  }
  free(temp3);
 
  temp3 = strdup(temp1);                          
  while((temp2 = strchr(temp1,'>')) != NULL) {   
    strcpy(temp3, temp2+1);                      
    realloc(temp1, strlen(temp1)+4);             
    strcpy(temp2, "&gt;");                       
    strcat(temp1, temp3);                        
  }
  free(temp3); 
   
  time(&currtime);
  strftime(timestring, 48, "%H:%M:%S", gmtime(&currtime));
       
  fprintf(fout, "<font color=\"#3333ff\"><small><small>%s:</small></small>&nbsp;%s:<font color=\"#ff0000\">%s<font><br>\n", timestring, nick, temp1);
  free(temp1);
  
  
 
//  fprintf(fout, "<font color=\"#3333ff\"><small><small>%s:</small></small>&nbsp;%s:<font color=\"#ff0000\">%s<font><br>\n", timestring, nick, info);
  fflush(fout);
  

}


struct chfiles *find_logfile(char *channel)
{
	struct chfiles *logfiles ;

	logfiles = channel_files ;
	
	while(logfiles != NULL) {
		if( strncmp(channel, logfiles->channel, 20) == 0 ) {
			return(logfiles) ;
		} 
		logfiles = logfiles->next ;
	}
	return(NULL) ;	
}


void releaseLogfiles(void) {

	struct chfiles *logfile, *tempfile ;

	logfile = channel_files ;
	
	while(logfile != NULL) {
   
     tempfile = logfile;
     logfile  = logfile->next ;
     
      UnlinkListItem(logfile, channel_files) ;
      fclose(tempfile->file);
		free(tempfile->channel);
      free(tempfile);      
		
	}
}

 
FILE* GetFileHandle(char *channel) {

  struct chfiles  *logfile, *tempfile;
  time_t           currtime;
  struct tm        currtimes;
  struct tm        filetimes;
  char             temp[40];
  char             filename[512];

   time( & currtime );
   currtimes = *gmtime( & currtime);
   strftime(temp, 38, "-%d-%m-%Y", & currtimes); // "-10-01-2005"
  
  if ((logfile = find_logfile(channel)) != NULL) {
  
    filetimes = *gmtime( & logfile->created );
                
    if ( filetimes.tm_yday != currtimes.tm_yday ) {
        fclose(logfile->file);

        filename[0]='\0';                             // ""
        strncat(filename, LOG, 200);                  // "/files/prog/src/acidblood/logs"
        strcpy((strrchr(filename, '/')+1), "html/");  // "/files/prog/src/acidblood/html/"
        strncat(filename, channel, 20);               // "/files/prog/src/acidblood/html/acidblood"
        
        strcat(filename, temp);                      // "/files/prog/src/acidblood/html/acidblood-10-01-2005"
        strcat(filename, ".html");                    // "/files/prog/src/acidblood/html/acidblood-10-01-2005.html"

        if ((logfile->file = fopen(filename, "a")) == NULL) {
          return NULL;
        }
        logfile->created = currtime;
      }
    } else {
      filename[0]='\0';                             // ""
      strncat(filename, LOG, 200);                  // "/files/prog/src/acidblood/logs"
      strcpy((strrchr(filename, '/')+1), "html/");  // "/files/prog/src/acidblood/html/"
      strncat(filename, channel, 20);               // "/files/prog/src/acidblood/html/acidblood"
    //  strftime(temp1, 20, "-%d-%m-%Y", & working_time); // "-10-01-2005"
      strcat(filename, temp);                      // "/files/prog/src/acidblood/html/acidblood-10-01-2005"
      strcat(filename, ".html");                    // "/files/prog/src/acidblood/html/acidblood-10-01-2005.html"

      if ((logfile = malloc(sizeof(struct chfiles))) == NULL) {
        return NULL;
      }

      logfile->created = currtime;
      logfile->channel = strdup(channel);
      if ((logfile->file = fopen(filename, "a")) == NULL) {
        free(logfile);
        return NULL;
      }
      LinkToList(logfile, tempfile, channel_files) ;	
    }
  return (logfile->file);
}



